unit Main;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.ExtCtrls, Vcl.StdCtrls, Vcl.ExtDlgs, GDIPAPI, GDIPOBJ,
  System.Types;

type
  B2array = array of array of SMALLINT;

  TForm1 = class(TForm)
    FileOpenBtn: TButton;
    Image1: TImage;
    Image2: TImage;
    OpenPictureDialog1: TOpenPictureDialog;
    matchingBtn: TButton;
    thresholdEdit: TLabeledEdit;
    Label1: TLabel;
    ZNCCBtn: TButton;
    procedure FileOpenBtnClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Image1MouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure Image1MouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
    procedure Image1MouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure matchingBtnClick(Sender: TObject);
    procedure ZNCCBtnClick(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}
type
  TMatchdata = Record
    X     : Integer;
    Y     : Integer;
    Match : Double;
  End;

const
  OpenFileFilter =
    '摜t@C|*.png;*.jpg;*.gif;*.bmp;*.tif;*.ico;*.wdp'+
    '|*.png|*.png' +
    '|*.jpg|*.jpg' +
    '|*.gif|*.gif' +
    '|*.bmp|*.bmp' +
    '|*.tif|*.tif' +
    '|*.ico|*.ico' +
    '|*.wdp|*.wdp';

  SaveFileFilter =
    '摜t@C|*.png;*.jpg;*.gif;*.bmp;*.tif;*.wdp' +
    '|*.png|*.png' +
    '|*.jpg|*.jpg' +
    '|*.gif|*.gif' +
    '|*.bmp|*.bmp' +
    '|*.tif|*.tif' +
    '|*.wdp|*.wdp';

  ImageHW   = 384;    // \gTCY
  SampleHW  = 120;

var
  InputDBitmap  : TBitmap;                    // ̓f[^[\prbg}bv
  OutputBitmap  : TBitmap;                    // ]摜\prbg}bv
  SampleBitmap  : TBitmap;
  GHeight       : Integer;                    // ̓f[^[摜
  GWidth        : Integer;                    // ̓f[^[摜
  IHeight       : Integer;                    // ̓f[^[摜
  IWidth        : Integer;                    // ̓f[^[摜

  VRect         : Trect;                      // \TCYݒp
  SRect         : Trect;                      // \TCYݒp
  InFilename    : string;                     // ̓t@C

  BlueMat       : B2array;                    // z
  GreenMat      : B2array;                    // Δz
  RedMat        : B2array;                    // Ԕz

  SBlueMat      : B2array;                    // Tvz
  SGreenMat     : B2array;                    // TvΔz
  SRedMat       : B2array;                    // TvԔz

  Drawing       : Boolean;                    // }EXIg\tO
  Origin        : TPoint;                     // }EXX^[gʒu
  EndPoint      : TPoint;                     // }EXAbvʒu
  NewMove       : Boolean;                    // }EXVړ
  FOpenF        : Boolean;                    // t@CJtO
  SWidth        : integer;                    // Tv摜
  SHeight       : integer;                    // Tv摜
  MatchMat      : array of TMatchdata;        // }b`f[^[


procedure TForm1.FileOpenBtnClick(Sender: TObject);
var
  WIC         : TWICImage;
  IHeight     : Integer;
  IWidth      : Integer;
  X, Y        : Integer;
  PBA         : PBytearray;
  PFD, WP     : Integer;
begin
  FOpenF := False;
  VRect := Rect(0, 0, Image1.Width, Image1.Height);
  Image1.Canvas.Brush.Style := bsSolid;
  Image1.Canvas.Brush.Color := clBtnface;
  Image1.Canvas.FillRect(VRect);                              // Canvas 摜
  OpenPictureDialog1.Filter := OpenFileFilter;                // t@CI[vtB^[̐ݒ
  if OpenPictureDialog1.Execute = true then                          // t@Cw肳ꂽ
    begin
      WIC := TWICImage.Create;                                // TWICImage̐
      try
        InFilename := OpenPictureDialog1.FileName;            // t@C̎擾
        WIC.LoadFromFile(InFilename);                         // 摜̓ǂݍ
        GHeight := WIC.Height;                                // 摜擾
        GWidth  := WIC.Width;                                 // 摜
        IWidth  := ImageHW;                                   // o͐C[W1̕
        IHeight := ImageHW;                                   // o͐C[W1̍
        if GHeight <= GWidth then                             // cɂo̓TCYݒ
          IHeight := Round(IWidth * GHeight / GWidth)
        else
          IWidth := Round(IHeight * GWidth / GHeight);
        Image1.Width := IWidth;
        Image1.Height:= IHeight;
        Image1.Picture.Bitmap.SetSize(IWidth, IHeight);
        VRect := Rect(0, 0, IWidth, IHeight);                 // o͘gݒ
        InputDBitmap.Assign(WIC);                             // Tbitmap  TWICImageRs[
      finally
        WIC.Free;                                             // TWICImage 
      end;
    end
    else exit;
  OutputBitmap.Width  := GWidth;
  OutputBitmap.Height := GHeight;
  setLength(BlueMat, GHeight, GWidth);                        // 摜z̊m
  setLength(GreenMat, GHeight, GWidth);
  setLength(RedMat, GHeight, GWidth);
  PFD := 3;
  if InputDBitmap.PixelFormat = pf32bit then PFD := 4;
  for Y := 0 to Gheight - 1 do begin                          // J[摜zɕϊ
    PBA := InputDBitmap.ScanLine[Y];
    for X := 0 to GWidth - 1 do begin
      WP := X * PFD;
      BlueMat[Y][X]  := PBA[WP];
      GreenMat[Y][X] := PBA[WP + 1];
      RedMat[Y][X]   := PBA[WP + 2];
    end;
  end;
  for Y := 0 to Gheight - 1 do begin                          // J[z񂩂rbg}bvɕϊ
    PBA := OutputBitmap.ScanLine[Y];
    for X := 0 to GWidth - 1 do begin
      WP := X * 3;
      PBA[WP]     := BlueMat[Y][X];
      PBA[WP + 1] := GreenMat[Y][X];
      PBA[WP + 2] := RedMat[Y][X];
    end;
    Image1.Canvas.StretchDraw(VRect, OutputBitmap);           // o͘gɕϔ{o
  end;
  FOpenF := True;
end;

procedure TForm1.FormCreate(Sender: TObject);
var
  IBitmap : Tbitmap;
begin
  Left := (Screen.Width - Width) div 2;
  Top  := (Screen.Height - Height) div 2;
  Image1.Width  := ImageHW;
  Image1.Height := ImageHW;
  IBitmap := Tbitmap.Create;
  IBitmap.Width := SampleHW;
  IBitmap.Height := SampleHW;
  IMage2.Picture.Bitmap := IBitmap;
  Image2.Width  := SampleHW;
  IMage2.Height := SampleHW;
  IBitmap.Free;
  InputDBitmap  := TBitmap.Create;
  OutputBitmap  := TBitmap.Create;
  SampleBitmap  := TBitmap.Create;
  InputDBitmap.PixelFormat := pf24bit;
  OutputBitmap.PixelFormat := pf24bit;
  SampleBitmap.PixelFormat := pf24bit;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  InputDBitmap.Free;
  OutputBitmap.Free;
  SampleBitmap.Free;
end;

procedure TForm1.Image1MouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  Drawing := True;                                                        // }EX_EtOZbg
  Image1.Canvas.Brush.Color := clWhite;
  Image1.Canvas.Brush.Style := bsClear;
  Image1.Canvas.Pen.Color := ClBlack;
  Image1.Canvas.Pen.Width := 2;
  Origin := Point(X, Y);                                                  // W̕ۑ
  NewMove := True;
end;

procedure TForm1.Image1MouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
begin
  if Drawing and (Shift = [ssLeft]) then begin
    Image1.Canvas.Pen.Mode := pmNotXor;                                   // y[h Not Xor
    if not NewMove then begin
      Image1.Canvas.MoveTo(Origin.X, Origin.Y);                           // O̐
      Image1.Canvas.LineTo(EndPoint.X, Origin.Y);
      Image1.Canvas.LineTo(EndPoint.X, EndPoint.Y);
      Image1.Canvas.LineTo(Origin.X, EndPoint.Y);
      Image1.Canvas.LineTo(Origin.X, Origin.Y);                           // O̐
    end;
    EndPoint := point(X, Y);                                              // VWۑ
    Image1.Canvas.MoveTo(Origin.X, Origin.Y);                             // O̐
    Image1.Canvas.LineTo(EndPoint.X, Origin.Y);
    Image1.Canvas.LineTo(EndPoint.X, EndPoint.Y);
    Image1.Canvas.LineTo(Origin.X, EndPoint.Y);
    Image1.Canvas.LineTo(Origin.X, Origin.Y);                             // O̐
    NewMove := False;
    Image1.Canvas.Pen.Mode := pmCopy;                                     // y[hʏ
  end;
end;

procedure TForm1.Image1MouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
  TMPI        : integer;
  Scal        : Double;
  OX, EX, OY, EY : Integer;
  PBA         : PBytearray;
  X0, Y0, WP  : Integer;
  SHW         : Integer;
begin
  if not Drawing or NewMove then exit;
  Image1.Canvas.Pen.Mode := pmNotXor;                                   // y[h Not Xor
  Image1.Canvas.MoveTo(Origin.X, Origin.Y);                             // O̐
  Image1.Canvas.LineTo(EndPoint.X, Origin.Y);
  Image1.Canvas.LineTo(EndPoint.X, EndPoint.Y);
  Image1.Canvas.LineTo(Origin.X, EndPoint.Y);
  Image1.Canvas.LineTo(Origin.X, Origin.Y);                             // O̐
  Image1.Canvas.Pen.Mode := pmCopy;                                     // y[hʏ
  NewMove := False;
  Drawing := False;
  // ͈͎w萳K֕ϊ
  if Origin.X > EndPoint.X then begin
    TMPI := Origin.X;
    Origin.X := EndPoint.X;
    EndPoint.X := TMPI;
  end;
  if Origin.Y > EndPoint.Y then begin
    TMPI := Origin.Y;
    Origin.Y := EndPoint.Y;
    EndPoint.Y := TMPI;
  end;
  IWidth  := Image1.Width;
  IHeight := Image1.Height;
  // }EX|Cg摜Wɕϊ
  Scal := GWidth / IWidth;                                // 摜ƕ\摜̔{
  OX := Round(Origin.X * Scal);
  EX := Round(EndPoint.X * Scal);
  OY := Round(Origin.Y * Scal);
  EY := Round(EndPoint.Y * Scal);
  // ͈̓TCYݒ
  SWidth  := EX - OX;
  SHeight := EY - OY;
  // }EXI͈͂̐ I͈͂ݒ͈͂𒴂ݒ͈͂ɐ
  SHW := Round(SampleHW * Scal);
  if SWidth > SHW then begin
    SWidth := SHW;
  end;
  if SHeight > SHW then begin
    SHeight := SHW;
  end;
  // Tv摜\gݒ
  Image2.Width  := Round(SWidth / scal);
  Image2.Height := Round(SHeight / scal);
  SRect := Rect(0, 0, Image2.Width, Image2.Height);
  //摜̈ꕔImage1ɕ`
  if FOpenF then begin
    SampleBitmap.Width := SWidth;
    SampleBitmap.Height := SHeight;
    setLength(SBlueMat, SHeight, SWidth);
    setLength(SGreenMat, SHeight, SWidth);
    setLength(SRedMat, SHeight, SWidth);
    // w͈͂̉摜z񂩂擾
    for Y0 := 0 to SHeight - 1 do
      for X0 := 0 to SWidth - 1 do begin
        SBlueMat[Y0, X0] := BlueMat[Y0 + OY, X0 + OX];
        SGreenMat[Y0, X0] := GreenMat[Y0 + OY, X0 + OX];
        SRedMat[Y0, X0] := RedMat[Y0 + OY, X0 + OX];
      end;
    // 擾zf[^[rbg}bvɕϊ
    for Y0 := 0 to  SHeight -1 do begin
      PBA := SampleBitmap.ScanLine[Y0];
      for X0 := 0 to SWidth -1 do begin
        WP := X0 * 3;
        PBA[WP    ] := SBlueMat[Y0, X0];
        PBA[WP + 1] := SGreenMat[Y0, X0];
        PBA[WP + 2] := SRedMat[Y0, X0];
      end;
    end;
    Image2.Canvas.StretchDraw(SRect, SampleBitmap);   // Tvo͘gɏo
  end;
end;

procedure TForm1.matchingBtnClick(Sender: TObject);
var
  XLeng   : Integer;
  YLeng   : Integer;
  TLeng   : Integer;
  XI, YI  : Integer;
  XS, YS  : Integer;
  Match   : Integer;
  CountS  : Integer;
  threshold : Integer;
  PointArry : array of TPoint;
  TopD      : Integer;
  LeftD     : Integer;
  BottomD   : Integer;
  RightD    : Integer;
  Scal      : Double;
  MinD      : Integer;
begin
  Val(thresholdEdit.Text, threshold, YI);
  if YI <> 0 then threshold := 0;
  XLeng := GWidth - SWidth;
  YLeng := GHeight - SHeight;
  TLeng := XLeng * YLeng;
  SetLength(MatchMat, TLeng);
  MinD := MAXINT;
  for YI := 0 to Yleng - 1 do
    for XI := 0 to XLeng - 1 do begin
      MatchMat[YI * XLeng + XI].Match := 0;
      MatchMat[YI * XLeng + XI].X := XI;
      MatchMat[YI * XLeng + XI].Y := YI;
      Match := 0;
      for YS := 0 to SHeight - 1 do
        for XS := 0 to SWidth - 1 do begin
          Match := Match + abs(BlueMat[YI + YS, XI + XS] - SBlueMat[YS, XS]);   // ΒlvZ
          Match := Match + abs(GreenMat[YI + YS, XI + XS] - SGreenMat[YS, XS]); // ΒlvZ
          Match := Match + abs(RedMat[YI + YS, XI + XS] - SRedMat[YS, XS]);     // ΒlvZ
        end;
      MatchMat[YI * XLeng + XI].Match := Match;
      if Match < MinD then MinD := Match;
    end;
  CountS := 0;
  for YI := 0 to Yleng - 1 do
    for XI := 0 to XLeng - 1 do
      if MatchMat[YI * Xleng + XI].Match <= threshold then begin      // ݒl菬l
        inc(Counts);
        SetLength(PointArry, Counts);                                 // Wۑpzm
        PointArry[Counts - 1].X := MatchMat[YI * Xleng + XI].X;       // Wۑ
        PointArry[Counts - 1].Y := MatchMat[YI * Xleng + XI].Y;
      end;
  Scal := IWidth / GWidth;                                    // 摜ƕ\摜̔{
  if CountS > 0 then begin
    Image1.Canvas.StretchDraw(VRect, OutputBitmap);           // o͘gɕϔ{o
    for YI := 0 to CountS - 1 do begin
      TopD := Round(PointArry[YI].Y * Scal);
      LeftD := Round(PointArry[YI].X * Scal);
      BottomD := TopD + Image2.Height;
      RightD := LeftD + Image2.Width;
      Image1.Canvas.Pen.Color := clRed;
      Image1.Canvas.Pen.Width := 2;
      Image1.Canvas.MoveTo(LeftD, TopD);
      Image1.Canvas.LineTo(RightD, TopD);
      Image1.Canvas.LineTo(RightD, BottomD);
      Image1.Canvas.LineTo(LeftD, BottomD);
      Image1.Canvas.LineTo(LeftD, TopD);
    end;
  end;
  Label1.Caption := 'ŏl ' + IntTostr(MinD);
end;

procedure TForm1.ZNCCBtnClick(Sender: TObject);
var
  XLeng   : Integer;
  YLeng   : Integer;
  TLeng   : Integer;
  MinD    : Double;
  MN      : Double;
  O       : Integer;
  S       : Integer;
  IT      : Int64;
  I       : Int64;
  T       : Int64;
  I2      : Int64;
  T2      : Int64;
  threshold : double;
  XI, YI  : Integer;
  XS, YS  : Integer;
  Match   : Double;
  CountS  : Integer;
  PointArry : array of TPoint;
  TopD      : Integer;
  LeftD     : Integer;
  BottomD   : Integer;
  RightD    : Integer;
  Scal      : Double;
begin
  Val(thresholdEdit.Text, threshold, YI);
  if YI <> 0 then threshold := 0;
  XLeng := GWidth - SWidth;
  YLeng := GHeight - SHeight;
  TLeng := XLeng * YLeng;
  SetLength(MatchMat, TLeng);
  MN := 1 / (SHeight * SWidth * 3);                         // OF
  MinD  := MAXINT;
  for YI := 0 to Yleng - 1 do                               // 摜Sʌ
    for XI := 0 to XLeng - 1 do begin
      MatchMat[YI * XLeng + XI].Match := 0;                 // 
      MatchMat[YI * XLeng + XI].X := XI;                    // W
      MatchMat[YI * XLeng + XI].Y := YI;                    // W
      IT  := 0;                                             // 
      I   := 0;
      T   := 0;
      I2  := 0;
      T2  := 0;
      for YS := 0 to SHeight - 1 do                         // ev[g͈̓}b`OvZ
        for XS := 0 to SWidth - 1 do begin
          O := BlueMat[YI + YS, XI + XS];                   // 
          S := SBlueMat[YS, XS];
          IT := IT + O * S;                                 // hs
          I  := I  + O;                                     // h
          T  := T  + S;                                     // s
          I2 := I2 + O * O;                                 // I^2
          T2 := T2 + S * S;                                 // T^2
          O := GreenMat[YI + YS, XI + XS];                  // Ώ
          S := SGreenMat[YS, XS];
          IT := IT + O * S;
          I  := I  + O;
          T  := T  + S;
          I2 := I2 + O * O;
          T2 := T2 + S * S;
          O := RedMat[YI + YS, XI + XS];                    // ԏ
          S := SRedMat[YS, XS];
          IT := IT + O * S;
          I  := I  + O;
          T  := T  + S;
          I2 := I2 + O * O;
          T2 := T2 + S * S;
        end;
      Match := 100;                                         // ̒lZbg
      if (I2 <> 0) and (T2 <> 0) then                       // 摜̉ZG[h~
//          Match := IT / sqrt(I2 * T2);
        Match := (IT - I * T * MN) / sqrt((I2 - I * I * MN) * (T2 - T * T * MN));   // X̌vZ͕ǓvZ
      Match := abs(1 - Match);                              // ԃ}b`O1Ȃ̂1Ƃ̍vZ
      MatchMat[YI * XLeng + XI].Match := Match;             // }b`Olۑ
      if Match < MinD then MinD := Match;                   // ŏl
    end;
  CountS := 0;
  for YI := 0 to Yleng - 1 do
    for XI := 0 to XLeng - 1 do
      if MatchMat[YI * Xleng + XI].Match <= threshold then begin // ݒl菬l
        inc(Counts);
        SetLength(PointArry, Counts);                            // Wۑpzm
        PointArry[Counts - 1].X := MatchMat[YI * Xleng + XI].X;  // Wۑ
        PointArry[Counts - 1].Y := MatchMat[YI * Xleng + XI].Y;
      end;
  Scal := IWidth / GWidth;                                  // 摜ƕ\摜̔{
  if CountS > 0 then begin
    Image1.Canvas.StretchDraw(VRect, OutputBitmap);           // o͘gɕϔ{o
    for YI := 0 to CountS - 1 do begin
      TopD := Round(PointArry[YI].Y * Scal);
      LeftD := Round(PointArry[YI].X * Scal);
      BottomD := TopD + Image2.Height;
      RightD := LeftD + Image2.Width;
      Image1.Canvas.Pen.Color := clRed;
      Image1.Canvas.Pen.Width := 2;
      Image1.Canvas.MoveTo(LeftD, TopD);
      Image1.Canvas.LineTo(RightD, TopD);
      Image1.Canvas.LineTo(RightD, BottomD);
      Image1.Canvas.LineTo(LeftD, BottomD);
      Image1.Canvas.LineTo(LeftD, TopD);
    end;
  end;
  Label1.Caption := 'ŏl ' + floatTostr(MinD);

end;

end.
